namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Components.Auth;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Economy;
    using Eco.Gameplay.Housing;
    using Eco.Gameplay.Interactions;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Minimap;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Gameplay.Pipes.LiquidComponents;
    using Eco.Gameplay.Pipes.Gases;
    using Eco.Gameplay.Systems.Tooltip;
    using Eco.Shared;
    using Eco.Shared.Math;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.View;
    using Eco.Shared.Items;
    using Eco.Gameplay.Pipes;
    using Eco.World.Blocks;
    

    [Serialized]
    public partial class LaserItem : WorldObjectItem<LaserObject>
    {
        public override string FriendlyName { get { return "Laser"; } } 
        public override string Description  { get { return  "AVOID DIRECT EYE EXPOSURE"; } }

        static LaserItem()
        {
            
        }

        [TooltipChildren] public HousingValue HousingTooltip { get { return HousingVal; } }
        [TooltipChildren] public static HousingValue HousingVal { get { return new HousingValue() 
                                                {
                                                    Category = "Industrial",
                                                    TypeForRoomLimit = "", 
        };}}
    }


    [RequiresSkill(typeof(PlanetaryDefenseEngineeringSkill), 1)]
    public partial class LaserRecipe : Recipe
    {
        public LaserRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<LaserItem>(),
            };

            this.Ingredients = new CraftingElement[]
            {
                new CraftingElement<GoldIngotItem>(typeof(PlanetaryDefenseEngineeringEfficiencySkill), 150, PlanetaryDefenseEngineeringEfficiencySkill.MultiplicativeStrategy),
                new CraftingElement<SteelItem>(typeof(PlanetaryDefenseEngineeringEfficiencySkill), 150, PlanetaryDefenseEngineeringEfficiencySkill.MultiplicativeStrategy),
                new CraftingElement<CircuitItem>(typeof(PlanetaryDefenseEngineeringEfficiencySkill), 75, PlanetaryDefenseEngineeringEfficiencySkill.MultiplicativeStrategy),   
            };
            SkillModifiedValue value = new SkillModifiedValue(150, PlanetaryDefenseEngineeringSpeedSkill.MultiplicativeStrategy, typeof(PlanetaryDefenseEngineeringSpeedSkill), Localizer.Do("craft time"));
            SkillModifiedValueManager.AddBenefitForObject(typeof(LaserRecipe), Item.Get<LaserItem>().UILink(), value);
            SkillModifiedValueManager.AddSkillBenefit(Item.Get<LaserItem>().UILink(), value);
            this.CraftMinutes = value;
            this.Initialize("Laser", typeof(LaserRecipe));
            CraftingComponent.AddRecipe(typeof(FactoryObject), this);
        }
    }
}